// Written by TeTeT

ttt_bases = [Base1, Base2, Base3, Base4, Base5];
ttt_lurkers = [Lurker1, Lurker2, Lurker3, Lurker4, Lurker5, Lurker6, Lurker7, Lurker8, Lurker9];
ttt_villages = [Village1, Village2, Village3, Village4];
ttt_callsigns = ["blue", "red", "yellow", "orange", "black", "brown", "purple", "pink", "white", "black", "green"];
ttt_spawnPoints = [ SpawnNorth, SpawnWest, SpawnSouth, SpawnEast ];
ttt_VCAA = [VC1, VC2, VC3, VC4, VC5, VC6, VC7, VC8, VC9, VC10, VC11, VC12, VC13];
ttt_howitzers = [h1, h2, h3];

Uns_Radio_enabled = false;

ttt_fnc_createPassengers = {
	params ["_pos", "_heli"];
	private _crewCount = count (crew _heli);
	private _allSeats = count (fullCrew [_heli, "", true]);
	private _openSeats = _allSeats - _crewCount;
	private _grp = createGroup west;

	if (_openSeats < 4) then {
		_grp = [_pos] call ttt_fnc_createOfficer;
	} else {
		if (_openSeats < 10) then {
			private _create = selectRandom [ttt_fnc_createOfficer, ttt_fnc_createTeam];
			_grp = [_pos] call _create;
		} else {
			private _create = selectRandom [ttt_fnc_createOfficer, ttt_fnc_createTeam, ttt_fnc_createSquad];
			_grp = [_pos] call _create;
		};
	};
	_grp;
};

ttt_fnc_createOfficer = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_USMC_65_COM" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createTeam = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_USMC_65_SL" createUnit [_pos, _grp];
	"uns_men_USMC_65_RTO" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF1" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF2" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_createSquad = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup west;
	"uns_men_USMC_65_SL" createUnit [_pos, _grp];
	"uns_men_USMC_65_RTO" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF1" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF2" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF3" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF4" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF5" createUnit [_pos, _grp];
	"uns_men_USMC_65_RF6" createUnit [_pos, _grp];
	"uns_men_USMC_65_MED" createUnit [_pos, _grp];
	"uns_men_USMC_65_GL" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_VCPatrol = {
	params ["_pos"];
	_pos = _pos getPos [20, random 360];
	private _grp = createGroup east;
	"uns_men_VC_mainforce_nco" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_HMG" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RTO" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_LMG" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF1" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF2" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF3" createUnit [_pos, _grp];
	"uns_men_VC_mainforce_RF4" createUnit [_pos, _grp];
	private _callsign = format ["VC-%1", [] call ttt_fnc_getCallSign];
	_grp setGroupId [_callsign];
	_grp;
};

ttt_fnc_assaultLZ = {
	params ["_pos", "_heli"];

	waitUntil {sleep 0.1; _heli distance _pos < 1500};

	private _spawn = _pos getPos [300, random 360];
	private _squad = [_spawn] call ttt_fnc_VCPatrol;
	private _wp = _squad addWaypoint [_pos, 10];
	_wp setWaypointType "SAD";
	_squad setCombatMode "RED";
	_squad;
};

ttt_fnc_board = {
	params ["_grp", "_heli"];

	{_x assignAsCargo _heli} forEach units _grp;
	private _wp = _grp addWaypoint [(getPos _heli), 5];
	_wp setWaypointType "GETIN";
	waitUntil {{alive _x} count (units _grp) == {_x in _heli} count (units _grp)};
	(leader _grp) sideChat "All aboard";
	_grp;
};

ttt_fnc_disembark = {
	params ["_grp", "_heli"];
    {unassignVehicle _x} forEach units _grp;
    private _wp = _grp addWaypoint [(getPos _heli),15];
    _wp setWaypointType "GETOUT";
	 waitUntil {{alive _x} count (units _grp) == {!(_x in _heli)} count (units _grp)};
	(leader _grp) sideChat "Bye";
	[_grp, getPos (leader _grp), 1000] call BIS_fnc_taskPatrol;
	_grp;
};


ttt_fnc_getCallSign = {
	private _nr = floor random 100;
	private _base = selectRandom ttt_callsigns;

	format ["%1-%2", _base, _nr];
};

ttt_fnc_dispatchLZTeam = {
	params ["_pos", "_heli"];

	private _grp = createGroup west;
	"uns_men_USMC_65_SL" createUnit [_pos, _grp];
	"uns_men_USMC_65_RTO" createUnit [_pos, _grp];
	private _callsign = [] call ttt_fnc_getCallSign;
	_grp setGroupId [_callsign];

	waitUntil {sleep 0.1; _pos distance _heli < 1000};

	if (alive leader _grp) then {
		(leader _grp) sideChat "Dropping smoke";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 5];
		_smoke setDamage 1;
	};
	true;
};

ttt_fnc_getRandomPos = {
	params ["_centerObject"];

	private _min = 2000;
	private _max = 5000;

	private _pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;

	// need to find a position not too far away
	while {_pos distance Center > 10000} do {
		_pos = [getPos _centerObject, _min, _max, 20, 0, 1, 0] call BIS_fnc_findSafePos;
	};

	_pos;
};

ttt_fnc_baseLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseHotLZ = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destPos = [_orig] call ttt_fnc_getRandomPos;
	private _dest = "Land_HelipadEmpty_F" createVehicle _destPos;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat "Fly to LZ marked on map";
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	[_destPos, _heli] spawn ttt_fnc_assaultLZ;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};




ttt_fnc_baseBase = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _destBases = ttt_bases - [ _orig ];
	private _dest = selectRandom _destBases;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ObjNull])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", getPos _dest];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_baseVillage = {
	params ["_heli"];
	private _orig = selectRandom ttt_bases;
	private _dest = selectRandom ttt_villages;
	private _destPos = getPos _dest;

	_heli vehicleChat format ["Fly to %1", _orig getVariable "name"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	// Exception for base5, hill950
	private _pos = getPos _orig;
	if (!isNull(_orig getVariable ["spawn", ""])) then {
		_pos = getPos (_orig getVariable "spawn");
	};
	private _grp = [_pos, _heli] call ttt_fnc_createPassengers;
	waitUntil {sleep 1; _heli distance _orig < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	[_destPos, _heli] spawn ttt_fnc_dispatchLZTeam;
	waitUntil {sleep 1; _heli distance _dest < 50 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};

ttt_fnc_streetBase = {
	systemChat "No written yet";
};

ttt_fnc_baseStreet = {
	systemChat "No written yet";
};

ttt_fnc_LZBase = {
	params ["_heli"];

	private _dest = selectRandom ttt_bases;
	private _destPos = getPos _dest;
	private _origPos = [_dest] call ttt_fnc_getRandomPos;
	private _orig = "Land_HelipadEmpty_F" createVehicle _origPos;

	_heli vehicleChat format ["Fly to LZ, see map marker"];
	private _origMarker = createMarkerLocal ["orig", getPos _orig];
	_origMarker setMarkerTypeLocal "hd_pickup";
	_origMarker setMarkerColorLocal "ColorWhite";
	private _grp = [getPos _orig, _heli] call ttt_fnc_createPassengers;
	[_grp, _heli] spawn {
		params ["_grp", "_heli"];
		private _pos = getPos leader _grp;
		waitUntil {sleep 0.1; _pos distance _heli < 1000};

		(leader _grp) sideChat "Dropping smoke";

		private _smoke = "SmokeShellPurple" createVehicle _pos;
		_smoke setPos [_pos select 0, _pos select 1, 5];
		_smoke setDamage 1;
		_smoke;
	};
	waitUntil {sleep 1; _heli distance _orig < 100 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Wait for boarding ...";
	[_grp, _heli] call ttt_fnc_board;
	sleep 1;
	deleteMarkerLocal "orig";

	_heli vehicleChat format ["Fly to %1", _dest getVariable "name"];
	private _lzMarker = createMarkerLocal ["LZ", _destPos];
	_lzMarker setMarkerTypeLocal "hd_objective";
	_lzMarker setMarkerColorLocal "ColorWhite";
	waitUntil {sleep 1; _heli distance _dest < 20 and speed _heli < 10 and isTouchingGround _heli};
	_heli vehicleChat "Unloading ...";
	[_grp, _heli] call ttt_fnc_disembark;
	sleep 1;
	_heli vehicleChat "Task completed";
	deleteMarkerLocal "LZ";
	_heli;
};


/**
[] spawn {

	waitUntil {alive player};
	sleep 1;

	private _heli = vehicle player;

	while {true} do {
		private _pos = [_heli] call ttt_getRandomPos;

		systemChat str _pos;

		sleep 5;

		private _lzMarker = createMarkerLocal ["LZ", _pos];
		_lzMarker setMarkerTypeLocal "hd_objective";

		hint "Fly to marker";

		waitUntil {_heli distance getMarkerPos _lzMarker < 10 and speed _heli < 10};
		deleteMarkerLocal "LZ";
		systemChat "LZ complete, getting next";
		sleep 1;
	};

};
**/

ttt_fnc_initBase = {
	params ["_base"];
	// spawn some patrols and other people at the camps
	private _patrol = [getPos _base] call ttt_fnc_createSquad;
	[_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;
	_patrol = [getPos _base] call ttt_fnc_createSquad;
	[_patrol, getPos _base, 100] call BIS_fnc_taskPatrol;
	_base;
};

ttt_fnc_initLurker = {
	params ["_pos"];
	private _lurkers = [_pos] call ttt_fnc_createSquad;
	private _wp = _lurkers addWaypoint [leader _lurkers, 5];
	_wp setWaypointType "Dismissed";
	_wp setWaypointFormation "Diamond";
};


ttt_fnc_initBases = {
	{
		[_x] call ttt_fnc_initBase;
	} forEach ttt_bases;
	{
		[_x] call ttt_fnc_initLurker;
	} forEach ttt_lurkers;
};

ttt_fnc_planeTraffic = {
	params ["_spawn"];

	private _plane = createVehicle ["uns_A4E_skyhawk_CAS", _spawn, [], 500, "FLY"];
	createVehicleCrew _plane;
	{
		private _wp = (group driver _plane) addWaypoint [_x, 1000];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _plane) addWaypoint [_spawn, 1000];
	_wp setWaypointType "CYCLE";
	_plane;
};

ttt_fnc_heloTraffic = {
	params ["_spawn"];
	private _type = selectRandom ["uns_UH1D_m60", "uns_UH1D_m60", "uns_ch34_USMC", "uns_H13_medevac_USMC", "uns_H13_amphib_USMC"];
	private _helo = createVehicle [_type, _spawn, [], 100, "FLY"];
	createVehicleCrew _helo;
	{
		private _wp = (group driver _helo) addWaypoint [_x, 0];
		_wp setWaypointType "MOVE";
		private _pos = [_x] call ttt_fnc_getRandomPos;
		_wp = (group driver _helo) addWaypoint [_pos, 0];
		_wp setWaypointType "MOVE";
	} forEach (ttt_bases call BIS_fnc_arrayShuffle);
	private _wp = (group driver _helo) addWaypoint [Center, 100];
	_wp setWaypointType "MOVE";
	_helo;
};

ttt_fnc_airTraffic = {
	private _planes = [];
	private _helos = [];
	{
		private _plane = [_x] call ttt_fnc_planeTraffic;
		_planes pushBack _plane;
	} forEach ttt_spawnPoints + ttt_spawnPoints + ttt_spawnPoints;
	{
		private _helo = [_x] call ttt_fnc_heloTraffic;
		_helos pushBack _helo;
	} forEach ttt_bases + ttt_villages;
	{
		private _pos = Center getPos [200 + random 200, random 360];
		private _helo = [_pos] call ttt_fnc_heloTraffic;
		_helos pushBack _helo;
	} forEach [1, 2, 3, 4, 5, 6, 7, 8];

	ttt_aircraft = [_planes, _helos];
	publicVariable "ttt_aircraft";
	ttt_aircraft;
};

ttt_fnc_VCAA = {
	private _type = "uns_dshk_high_VC";
	{
		private _pos = _x getPos [100, random 360];
		private _aa = createVehicle [_type, _pos, [], 10, "NONE"];
		createVehicleCrew _aa;

		if (selectRandom [true, false]) then {
			_pos = _x getPos [500, random 360];
			private _patrol = [_pos] call ttt_fnc_VCPatrol;
			[_patrol, _pos, 1000] call BIS_fnc_taskPatrol;
		};
		if (selectRandom [true, false]) then {
			_pos = _x getPos [500, random 360];
			private _patrol = [_pos] call ttt_fnc_VCPatrol;
			[_patrol, _pos, 1000] call BIS_fnc_taskPatrol;
		};
	} forEach ttt_VCAA;
};


ttt_fnc_opener = {
	waitUntil {sleep 0.1; !isNil "ttt_aircraft"};
	// plane or helo
	private _type = selectRandom [0,1];
	private _obj = selectRandom (ttt_aircraft select _type);
	private _pos = getPos _obj;
	_pos = [_pos select 0, _pos select 1, (_pos select 2) + 200];
	private _cam = "camera" camCreate _pos;
	_cam cameraEffect [ "internal", "back" ];
	_cam camSetFOV 0.7;

	private _i = 0;
	while {_i < 20} do {
		_cam camSetTarget _obj;
		_pos = _obj getPos [-50, getDir _obj];
		_pos = [_pos select 0, _pos select 1, (getPos _obj select 2) + 50];
		_cam camSetPos _pos;
		_cam camCommit 1;
		sleep 1;
		_i = _i + 1;
	};
	_cam cameraEffect [ "terminate", "back" ];
	camDestroy _cam;
	ttt_aircraft;
};

/**
 * Artillerty fire for ambiance
 **/
ttt_fnc_artyFire = {
	// this sleep is needed, otherwise the doWatch/doTarget seem to be not working
	sleep 60;
	{
		createVehicleCrew _x;
		private _tgt = "Land_HelipadEmpty_F" createVehicle (_x getPos [3000, getDir _x]);
		_tgt setPosATL [getPos _tgt select 0, getPos _tgt select 1, 1500];
		_x doWatch _tgt;
		_x doTarget _tgt;
		_x setVariable ["ttt_tgt", _tgt];
	} forEach ttt_howitzers;
	sleep 10;
	// fire the howitzers every 60 to 90 seconds
	while {true} do {
		{
			if (alive _x) then {
				_x fireAtTarget [(_x getVariable ["ttt_tgt", ObjNull])];
			};
		} forEach ttt_howitzers;
		sleep 60 + random(30);
	};
};

[] spawn {

	private _hc1Present = !(isNil "HC1");

	if (_hc1Present and isMultiplayer) then {
		if (!isServer and !hasInterface) then {
			systemChat "Spawning on HC";
			diag_log "On the HC";
			[] spawn ttt_fnc_initBases;
			[] spawn ttt_fnc_airTraffic;
			[] spawn ttt_fnc_VCAA;
			[] spawn ttt_fnc_artyFire;
		};
	} else {
		if (isServer) then {
			systemChat "Spawning on Server";
			diag_log "On the server";
			[] spawn ttt_fnc_initBases;
			[] spawn ttt_fnc_airTraffic;
			[] spawn ttt_fnc_VCAA;
			[] spawn ttt_fnc_artyFire;
		};
	};

	if (hasInterface) then {
		setViewDistance 4000;

		private _tasks = [ ttt_fnc_LZBase, ttt_fnc_baseStreet, ttt_fnc_streetBase, ttt_fnc_baseVillage, ttt_fnc_baseBase, ttt_fnc_baseLZ ];
		_tasks = [ ttt_fnc_baseLZ, ttt_fnc_baseBase, ttt_fnc_baseVillage, ttt_fnc_LZBase, ttt_fnc_baseHotLZ ];
		0 cutText ["Welcome to Vietnam", "BLACK IN", 15, false];
		waitUntil {alive player};
		[] spawn ttt_fnc_opener;
		sleep 20;

		systemChat "Initializing ...";
		sleep 1;
		Cmdr sideChat "Get out here - go do some flying!";
		sleep 5;

		waitUntil {sleep 1; vehicle player != player and (vehicle player) isKindOf "helicopter" and player == driver (vehicle player)};

		(vehicle player) vehicleChat "Welcome aboard! Tasking will start soon.";
		sleep 1;
		(vehicle player) vehicleChat "Boarding crew";
		createVehicleCrew (vehicle player);

		while {count _tasks > 0} do {
			private _task = selectRandom _tasks;
			_tasks = _tasks - [_task];

			[vehicle player] call _task;
			sleep 10;
		};
		Cmdr sideChat "All tasks completed, RTB!";
	};
};